/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+ 8-Bit Single-Chip Microcontrollers.
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	int_user.c
**  Abstract :	This file implements device driver for int module.
**  APIlib :	NEC78K0SKX1+.lib V1.50 [23 Feb. 2006]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/
#pragma	interrupt	INTP2	MD_INTP2

/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "int.h"
/*
*******************************************************************************
**  MacroDefine
*******************************************************************************
*/


/*
**-----------------------------------------------------------------------------
**
**  Abstract:
**	INTP2 Interrupt service routine.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**-----------------------------------------------------------------------------
*/
extern unsigned char	led_pattern;


void	time_wait(long time)
{
	while(time!=0){
	time--;
	}
}

__interrupt void MD_INTP2( void )
{
	/* TODO. Add user defined interrupt service routine */
	time_wait(20000);
	
	led_pattern++;
	if(led_pattern==8){
		led_pattern=0;
	}
}
