/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+ 8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation  assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	timer_user.c
**  Abstract :	This file implements device driver for the timer module.
**  APIlib:	NEC78K0SKX1+.lib V1.50 [23 Feb. 2006]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/

#pragma sfr
#pragma interrupt  INTTM000 MD_INTTM000
/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "timer.h"


/*
*******************************************************************************
**  MacroDefine
*******************************************************************************
*/
/*
**-----------------------------------------------------------------------------
**
**  Abstract:
**	This function is TM00 INTTM000 interrupt service routine.
**	
**  Parameters:
**	None
**
**  Returns:
**	None
**
**-----------------------------------------------------------------------------
*/

extern unsigned char	mune_red_count;
extern unsigned char	mune_blue_count;
extern unsigned char	mune_green_count;
extern unsigned char	ude_right_count;
extern unsigned char	ude_left_count;
extern unsigned char	belt_count;

extern unsigned char	mune_red_on;
extern unsigned char	mune_red_off;
extern unsigned char	mune_blue_on;
extern unsigned char	mune_blue_off;
extern unsigned char	mune_green_on;
extern unsigned char	mune_green_off;
extern unsigned char	ude_right_on;
extern unsigned char	ude_right_off;
extern unsigned char	ude_left_on;
extern unsigned char	ude_left_off;
extern unsigned char	belt_on;
extern unsigned char	belt_off;

extern unsigned char	int_count;

extern unsigned char	led_data;

extern unsigned char	led_change_count;

extern unsigned char	led_pattern;

extern const unsigned char pattern1[32];
extern const unsigned char pattern2[32];
extern const unsigned char pattern3[32];
extern const unsigned char pattern4[32];
extern const unsigned char pattern5[32];
extern const unsigned char pattern6[32];
extern const unsigned char pattern7[32];

void	led_change(void)
{
	led_change_count++;
	if(led_change_count==32){led_change_count=0;}
}

void	led_set(unsigned char number)
{
	switch(number){
		case 0:	mune_red_on=pattern1[led_change_count];
				mune_red_off=0x70-mune_red_on;
				mune_blue_on=pattern2[led_change_count];
				mune_blue_off=0x70-mune_blue_on;
				mune_green_on=pattern5[led_change_count];
				mune_green_off=0x70-mune_green_on;
				ude_right_on=pattern3[led_change_count];
				ude_right_off=0x70-ude_right_on;
				ude_left_on=pattern4[led_change_count];
				ude_left_off=0x70-ude_left_on;
				belt_on=pattern6[led_change_count];
				belt_off=0x70-belt_on;
				break;
		case 1:	mune_red_on=pattern5[led_change_count];
				mune_red_off=0x70-mune_red_on;
				mune_blue_on=pattern3[led_change_count];
				mune_blue_off=0x70-mune_blue_on;
				mune_green_on=pattern6[led_change_count];
				mune_green_off=0x70-mune_green_on;
				ude_right_on=pattern2[led_change_count];
				ude_right_off=0x70-ude_right_on;
				ude_left_on=pattern1[led_change_count];
				ude_left_off=0x70-ude_left_on;
				belt_on=pattern4[led_change_count];
				belt_off=0x70-belt_on;
				break;
		case 2:	mune_red_on=pattern2[led_change_count];
				mune_red_off=0x70-mune_red_on;
				mune_blue_on=pattern4[led_change_count];
				mune_blue_off=0x70-mune_blue_on;
				mune_green_on=pattern3[led_change_count];
				mune_green_off=0x70-mune_green_on;
				ude_right_on=pattern1[led_change_count];
				ude_right_off=0x70-ude_right_on;
				ude_left_on=pattern5[led_change_count];
				ude_left_off=0x70-ude_left_on;
				belt_on=pattern6[led_change_count];
				belt_off=0x70-belt_on;
				break;				
		case 3:	mune_red_on=pattern4[led_change_count];
				mune_red_off=0x70-mune_red_on;
				mune_blue_on=pattern5[led_change_count];
				mune_blue_off=0x70-mune_blue_on;
				mune_green_on=pattern6[led_change_count];
				mune_green_off=0x70-mune_green_on;
				ude_right_on=pattern2[led_change_count];
				ude_right_off=0x70-ude_right_on;
				ude_left_on=pattern3[led_change_count];
				ude_left_off=0x70-ude_left_on;
				belt_on=pattern1[led_change_count];
				belt_off=0x70-belt_on;
				break;
		case 4:	mune_red_on=pattern3[led_change_count];
				mune_red_off=0x70-mune_red_on;
				mune_blue_on=pattern6[led_change_count];
				mune_blue_off=0x70-mune_blue_on;
				mune_green_on=pattern1[led_change_count];
				mune_green_off=0x70-mune_green_on;
				ude_right_on=pattern4[led_change_count];
				ude_right_off=0x70-ude_right_on;
				ude_left_on=pattern5[led_change_count];
				ude_left_off=0x70-ude_left_on;
				belt_on=pattern2[led_change_count];
				belt_off=0x70-belt_on;
				break;
		case 5:	mune_red_on=pattern6[led_change_count];
				mune_red_off=0x70-mune_red_on;
				mune_blue_on=pattern1[led_change_count];
				mune_blue_off=0x70-mune_blue_on;
				mune_green_on=pattern2[led_change_count];
				mune_green_off=0x70-mune_green_on;
				ude_right_on=pattern3[led_change_count];
				ude_right_off=0x70-ude_right_on;
				ude_left_on=pattern5[led_change_count];
				ude_left_off=0x70-ude_left_on;
				belt_on=pattern4[led_change_count];
				belt_off=0x70-belt_on;
				break;
		case 6:	mune_red_on=pattern4[led_change_count];
				mune_red_off=0x70-mune_red_on;
				mune_blue_on=pattern3[led_change_count];
				mune_blue_off=0x70-mune_blue_on;
				mune_green_on=pattern1[led_change_count];
				mune_green_off=0x70-mune_green_on;
				ude_right_on=pattern5[led_change_count];
				ude_right_off=0x70-ude_right_on;
				ude_left_on=pattern2[led_change_count];
				ude_left_off=0x70-ude_left_on;
				belt_on=pattern6[led_change_count];
				belt_off=0x70-belt_on;
				break;
		case 7:	mune_red_on=pattern5[led_change_count];
				mune_red_off=0x70-mune_red_on;
				mune_blue_on=pattern6[led_change_count];
				mune_blue_off=0x70-mune_blue_on;
				mune_green_on=pattern4[led_change_count];
				mune_green_off=0x70-mune_green_on;
				ude_right_on=pattern1[led_change_count];
				ude_right_off=0x70-ude_right_on;
				ude_left_on=pattern2[led_change_count];
				ude_left_off=0x70-ude_left_on;
				belt_on=pattern3[led_change_count];
				belt_off=0x70-belt_on;
				break;
		}
}

void	led_bit_set(unsigned char set_bit,unsigned char set_data)
{
	switch(set_bit){
		case 0:	led_data=(led_data|0x01)&(set_data|0x3e);break;
		case 1:	led_data=(led_data|0x02)&((set_data<<1)|0x3d);break;
		case 2:	led_data=(led_data|0x04)&((set_data<<2)|0x3b);break;
		case 3:	led_data=(led_data|0x08)&((set_data<<3)|0x37);break;
		case 4:	led_data=(led_data|0x10)&((set_data<<4)|0x2f);break;
		case 5:	led_data=(led_data|0x20)&((set_data<<5)|0x1f);break;
	}
}

unsigned char led_check(unsigned check_bit)
{
	unsigned char data;
	
	switch(check_bit){
		case 0:data=led_data&0x01;break;
		case 1:data=(led_data&0x02)>>1;break;
		case 2:data=(led_data&0x04)>>2;break;
		case 3:data=(led_data&0x08)>>3;break;
		case 4:data=(led_data&0x10)>>4;break;
		case 5:data=(led_data&0x20)>>5;break;
	}
	return data;
}

__interrupt void MD_INTTM000( )
{
	/* TODO */
	int_count++;
	if(int_count==255){
			led_change();
			led_set(led_pattern);
	}
	mune_red_count--;
	mune_blue_count--;
	mune_green_count--;
	ude_right_count--;
	ude_left_count--;
	belt_count--;
	
	if(mune_red_count==0){
		
		if(led_check(0)==1){
			led_bit_set(0,0);			/* mune red led off */
			mune_red_count=mune_red_off;
			if(mune_red_count==0x00){
				led_bit_set(0,1);
				mune_red_count=mune_red_on;
			}
		}
		else{
			led_bit_set(0,1);			/* mune red led on */
			mune_red_count=mune_red_on;
			if(mune_red_count==0x00){
				led_bit_set(0,0);
				mune_red_count=mune_red_off;
			}
		
		}
	}

	if(mune_blue_count==0){
		
		if(led_check(1)==1){
			led_bit_set(1,0);			/* mune blue led off */
			mune_blue_count=mune_blue_off;
			if(mune_blue_count==0x00){
				led_bit_set(1,1);
				mune_blue_count=mune_blue_on;
			}
		}
		else{
			led_bit_set(1,1);			/* mune blue led on */
			mune_blue_count=mune_blue_on;
			if(mune_blue_count==0x00){
				led_bit_set(1,0);
				mune_blue_count=mune_blue_off;
			}
		}
	}
	
	if(mune_green_count==0){
		
		if(led_check(2)==1){
			led_bit_set(2,0);			/* mune green led off */
			mune_green_count=mune_green_off;
			if(mune_green_count==0x00){
				led_bit_set(2,1);
				mune_green_count=mune_green_on;
			}
		}
		else{
			led_bit_set(2,1);			/* mune green led on */
			mune_green_count=mune_green_on;
			if(mune_green_count==0x00){
				led_bit_set(2,0);
				mune_green_count=mune_green_off;
			}
		}
	}
	
	if(ude_right_count==0){
		
		if(led_check(3)==1){
			led_bit_set(3,0);			/* ude right led off */
			ude_right_count=ude_right_off;
			if(ude_right_count==0x00){
				led_bit_set(3,1);
				ude_right_count=ude_right_on;
			}
		}
		else{
			led_bit_set(3,1);			/* ude right led on */
			ude_right_count=ude_right_on;
			if(ude_right_count==0x00){
				led_bit_set(3,0);
				ude_right_count=ude_right_off;
			}
		}
	}
	
	if(ude_left_count==0){
		
		if(led_check(4)==1){
			led_bit_set(4,0);			/* ude left led off */
			ude_left_count=ude_left_off;
			if(ude_left_count==0x00){
				led_bit_set(4,1);
				ude_left_count=ude_left_on;
			}
		}
		else{
			led_bit_set(4,1);			/* ude left led on */
			ude_left_count=ude_left_on;
			if(ude_left_count==0x00){
				led_bit_set(4,0);
				ude_left_count=ude_left_off;
			}
		}
	}

	if(belt_count==0){
		
		if(led_check(5)==1){
			led_bit_set(5,0);			/* belt led off */
			belt_count=belt_off;
			if(belt_count==0x00){
				led_bit_set(5,1);
				belt_count=belt_on;
			}
		}
		else{
			led_bit_set(5,1);			/* belt led on */
			belt_count=belt_on;
			if(belt_count==0x00){
				led_bit_set(5,0);
				belt_count=belt_off;
			}
		}
	}

	
	
}
